//
//	Written by Dmitry Friesen, 20/03/2003
//	e-mail: dfriesen1946@mail.ru
//

//------------------------------------------------------------------------
//	Borland C++ Builder RTTI support for IDA
//

static BCCEnums(void) {
	auto id;

	id = AddEnum(-1, "__DPtypes", 0x1100000);
	AddConstEx(id, "__DPtypes_unk",		0x00,	0xffffffff);
	AddConstEx(id, "__DPtypes_int",		0x01,	0xffffffff);
	AddConstEx(id, "__DPtypes_char",	0x02,	0xffffffff);
	AddConstEx(id, "__DPtypes_enum",	0x03,	0xffffffff);
	AddConstEx(id, "__DPtypes_float",	0x04,	0xffffffff);
	AddConstEx(id, "__DPtypes_str",		0x05,	0xffffffff);
	AddConstEx(id, "__DPtypes_set",		0x06,	0xffffffff);
	AddConstEx(id, "__DPtypes_class",	0x07,	0xffffffff);
	AddConstEx(id, "__DPtypes_method",	0x08,	0xffffffff);
	AddConstEx(id, "__DPtypes_unk09",	0x09,	0xffffffff);
	AddConstEx(id, "__DPtypes_lstr",	0x0a,	0xffffffff);
	AddConstEx(id, "__DPtypes_wstr",	0x0b,	0xffffffff);
	AddConstEx(id, "__DPtypes_vernt",	0x0c,	0xffffffff);
	AddConstEx(id, "__DPtypes_array",	0x0d,	0xffffffff);
	AddConstEx(id, "__DPtypes_rec",		0x0e,	0xffffffff);
	AddConstEx(id, "__DPtypes_inter",	0x0f,	0xffffffff);
	AddConstEx(id, "__DPtypes_unk10",	0x10,	0xffffffff);
	AddConstEx(id, "__DPtypes_dynarr",	0x11,	0xffffffff);

	id = AddEnum(-1, "tpMask", 0x1100000);
	SetEnumBf(id, 1);
	AddConstEx(id, "TM_IS_STRUCT",		0x1,	0x1);
	AddConstEx(id, "TM_IS_CLASS",		0x2,	0x2);
	AddConstEx(id, "TM_IS_UNK04",		0x4,	0x4);
	AddConstEx(id, "TM_IS_UNK08",		0x8,	0x8);
	AddConstEx(id, "TM_IS_PTR",			0x10,	0x10);
	AddConstEx(id, "TM_IS_REF",			0x20,	0x20);
	AddConstEx(id, "TM_IS_VOIDPTR",		0x40,	0x40);
	AddConstEx(id, "TM_LOCALTYPE",		0x80,	0x80);
	AddConstEx(id, "TM_IS_CONST",		0x100,	0x100);
	AddConstEx(id, "TM_IS_VOLATILE",	0x200,	0x200);
	AddConstEx(id, "TM_IS_ARRAY",		0x400,	0x400);

	id = AddEnum(-1, "tpcFlags", 0x1100000);
	SetEnumBf(id, 1);
	AddConstEx(id, "CF_HAS_CTOR",		0x1,	0x1);
	AddConstEx(id, "CF_HAS_DTOR",		0x2,	0x2);
	AddConstEx(id, "CF_HAS_BASES",		0x4,	0x4);
	AddConstEx(id, "CF_HAS_VBASES",		0x8,	0x8);
	AddConstEx(id, "CF_HAS_VTABPTR",	0x10,	0x10);
	AddConstEx(id, "CF_HAS_VIRTDT",		0x20,	0x20);
	AddConstEx(id, "CF_HAS_RTTI",		0x40,	0x40);
	AddConstEx(id, "CF_DELPHICLASS",	0x80,	0x80);
	AddConstEx(id, "CF_HAS_FARVPTR",	0x1000,	0x1000);
	AddConstEx(id, "CF_HAS_GUID",		0x2000,	0x2000);
}

//------------------------------------------------------------------------
//
static BCCStruct(void) {
	auto id;
	
	id = GetStrucIdByName("_GUID");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_GUID", 0);
		AddStrucMember(id,"Data1",	0x0,	0x20000400,	-1,	4);
		AddStrucMember(id,"Data2",	0x4,	0x10000400,	-1,	2);
		AddStrucMember(id,"Data3",	0x6,	0x10000400,	-1,	2);
		AddStrucMember(id,"Data4",	0x8,	0x000400,	-1,	8);
	}

	id = GetStrucIdByName("_tpidc");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_tpidc", 0);
		AddStrucMember(id, "tpDtt",			0x00,	0x21100400,	-1,	4);
		AddStrucMember(id, "tpMask",		0x04,	0x11800400,	GetEnum("tpMask"),	2);
		AddStrucMember(id, "tpName",		0x06,	0x11100400,	-1,	2);
		AddStrucMember(id, "bParent",		0x08,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "tpcFlags",		0x0c,	0x21100400,	-1,	4);
		AddStrucMember(id, "tpcBaseList",	0x10,	0x11100400,	-1,	2);
		AddStrucMember(id, "tpcVbasList",	0x12,	0x11100400,	-1,	2);
		AddStrucMember(id, "mfnDel",		0x14,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "mfnMask",		0x18,	0x11100400,	-1,	2);
		AddStrucMember(id, "mfnMaskArr",	0x1a,	0x11100400,	-1,	2);
		AddStrucMember(id, "mfnDelArr",		0x1c,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "DtorCount",		0x20,	0x22200400,	-1,	4);
		AddStrucMember(id, "DtorAltCount",	0x24,	0x22200400,	-1,	4);
		AddStrucMember(id, "DtorAddr",		0x28,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "DtorMask",		0x2c,	0x11100400,	-1,	2);
		AddStrucMember(id, "DtorMembers",	0x2e,	0x11100400,	-1,	2);
		AddStrucMember(id, "Name",			0x30,	0x50000400,	0x0,	0);
	}
	
	id = GetStrucIdByName("_tpcMemb");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_tpcMemb", 0);
		AddStrucMember(id, "dmType",	0x00,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "dmOffs",	0x04,	0x21100400,	-1,			4);
	}
	
	id = GetStrucIdByName("_tpcBase");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_tpcBase", 0);
		AddStrucMember(id, "blType",	0x00,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "blOffs",	0x04,	0x21100400,	-1,		    4);
		AddStrucMember(id, "blFlafs",	0x08,	0x21100400,	-1,		    4);
	}
	
	id = GetStrucIdByName("_tpidp");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_tpidp", 0);
		AddStrucMember(id, "tpDtt",		0x0,	0x21100400,	-1,	4);
		AddStrucMember(id, "tpMask",	0x4,	0x11800400,	GetEnum("tpMask"),	2);
		AddStrucMember(id, "tpName",	0x6,	0x11100400,	-1,	2);
		AddStrucMember(id, "BaseType",	0x8,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "Name",		0xc,	0x50000400,	0x0,	0);
	}
	
	id = GetStrucIdByName("_tpida");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_tpida", 0);
		AddStrucMember(id, "tpDtt",		0x0,	0x21100400,	-1,	4);
		AddStrucMember(id, "tpMask",	0x4,	0x11800400,	GetEnum("tpMask"),	2);
		AddStrucMember(id, "tpName",	0x6,	0x11100400,	-1,	2);
		AddStrucMember(id, "BaseType",	0x8,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "Elements",	0xc,	0x22200400,	-1,	4);
		AddStrucMember(id, "Name",		0x10,	0x50000400,	0x0,	0);
	}
	
	id = GetStrucIdByName("_tpidcs");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_tpidcs", 0);
		AddStrucMember(id, "tpDtt",			0x0,	0x21100400,	-1,	4);
		AddStrucMember(id, "tpMask",		0x4,	0x11800400,	GetEnum("tpMask"),	2);
		AddStrucMember(id, "tpName",		0x6,	0x11100400,	-1,	2);
		AddStrucMember(id, "bParent",		0x8,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "tpcFlags",		0xc,	0x21800400,	GetEnum("tpcFlags"),	4);
		AddStrucMember(id, "Size",			0x10,	0x11100400,	-1,	2);
		AddStrucMember(id, "ExpDim",		0x12,	0x11100400,	-1,	2);
		AddStrucMember(id, "mfnDel",		0x14,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "mfnMask",		0x18,	0x11100400,	-1,	2);
		AddStrucMember(id, "mfnMaskArr",	0x1a,	0x11100400,	-1,	2);
		AddStrucMember(id, "mfnDelArr",		0x1c,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "Name",			0x20,	0x50000400,	0x0,	0);
	}

	id = GetStrucIdByName("_string");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_string", 0);
		AddStrucMember(id, "mask",	0x00,	0x20000400,	-1,		4);
		AddStrucMember(id, "size",	0x04,	0x20000400,	-1,		4);
		AddStrucMember(id, "Text",	0x08,	0x50000400,	0x0,	0);
	}

	id = GetStrucIdByName("TPropInfo");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "TPropInfo", 0);
		AddStrucMember(id, "PropType",		0x00,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "GetProc",		0x04,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "SetProc",		0x08,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "StoredProc",	0x0c,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "Index",			0x10,	0x21100400,	-1,	4);
		AddStrucMember(id, "Default",		0x14,	0x21100400,	-1,	4);
		AddStrucMember(id, "NameIndex",		0x18,	0x11100400,	-1,	2);
		AddStrucMember(id, "Name",			0x1a,	0x50000400,	0x1,	0);
	}

	id = GetStrucIdByName("TRTCInfo");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "TRTCInfo", 0);
		AddStrucMember(id, "_vtbl",	0x00,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_intf",	0x04,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_f08",	0x08,	0x21100400,	-1,	4);
		AddStrucMember(id, "_prp",	0x0c,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_dct",	0x10,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_acl",	0x14,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_mnu",	0x18,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_msg",	0x1c,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_cls",	0x20,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_sz",	0x24,	0x21100400,	-1,	4);
		AddStrucMember(id, "_bcls",	0x28,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_sce",	0x2c,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_clsc",	0x30,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_bfd",	0x34,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_dsp",	0x38,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_dhnd",	0x3c,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_init",	0x40,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_free",	0x44,	0x25500400,	0xffffffff,	4);
		AddStrucMember(id, "_dst",	0x48,	0x25500400,	0xffffffff,	4);
	}

	id = GetStrucIdByName("_tchd");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_tchd", 0);
		AddStrucMember(id, "_sign",	0x0,	0x800400,	GetEnum("__DPtypes"),	1);
		AddStrucMember(id, "Name",	0x1,	0x50000400,	0x1,	0);
	}
	
	id = GetStrucIdByName("_tcenum");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_tcenum", 0);
		AddStrucMember(id,"type",	0x0,	0x000400,	-1,	1);
		AddStrucMember(id,"min_max",	0x1,	0x20100400,	-1,	8);
	}

	id = GetStrucIdByName("_acl");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_acl", 0);
		AddStrucMember(id, "_idc",	0x00,	0x11100400,	-1,		2);
		AddStrucMember(id, "_unk",	0x02,	0x21100400,	-1,		4);
		AddStrucMember(id, "Name",	0x06,	0x50000400,	0x1,	0);
	}

	id = GetStrucIdByName("_mnu");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_mnu", 0);
		AddStrucMember(id, "_unk",	0x00,	0x11100400,	-1,				2);
		AddStrucMember(id, "_pfn",	0x02,	0x25500400,	0xffffffff,		4);
		AddStrucMember(id, "Name",	0x06,	0x50000400,	0x1,			0);
	}

	id = GetStrucIdByName("_tcint");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_tcint", 0);
		AddStrucMember(id,"type",		0x0,	0x000400,	-1,	1);
		AddStrucMember(id,"min_max",	0x1,	0x20100400,	-1,	8);
	}

	id = GetStrucIdByName("_tcset");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_tcset", 0);
		AddStrucMember(id,"type",	0x0,	0x000400,	-1,	1);
		AddStrucMember(id,"ptype",	0x1,	0x20500400,	0xffffffff,	4);
	}

	id = GetStrucIdByName("_tcclass");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_tcclass", 0);
		AddStrucMember(id, "_pvt",	0x0,	0x20500400,	0xffffffff,	4);
		AddStrucMember(id, "_pbc",	0x4,	0x20500400,	0xffffffff,	4);
		AddStrucMember(id, "_unk",	0x8,	0x10000400,	-1,			2);
		AddStrucMember(id, "Name",	0xa,	0x50000400,	0x1,		0);
	}

	id = GetStrucIdByName("_tcrec");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_tcrec",0);
		AddStrucMember(id, "ptype",	0x0,	0x20500400,	0xffffffff,	4);
		AddStrucMember(id, "_unk",	0x4,	0x20000400,	-1,	4);
	}

	id = GetStrucIdByName("_rtintf");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_rtintf", 0);
		AddStrucMember(id,"iid",	0x0,	0x60000400,	GetStrucIdByName("_GUID"),	16);
		AddStrucMember(id,"intf",	0x10,	0x20500400,	0xffffffff,	4);
		AddStrucMember(id,"_unk",	0x14,	0x20100400,	-1,	8);
	}

	id = GetStrucIdByName("_rtprop");
	if ( id == -1 ) {
		id = AddStrucEx(-1, "_rtprop", 0);
		AddStrucMember(id,"type",	0x0,	0x20500400,	0xffffffff,	4);
		AddStrucMember(id,"_unk",	0x4,	0x20000400,	-1,	4);
	}
}

// End of file.
